import javax.swing.JFrame;

import depGui.DepsShow;
import depGui.DibuixGraf;
import depGui.DepsShow.OutputFormat;

public class headerDeps {
	
	public static void main(String[] args) {
		
		DepsShow f = new DepsShow();
		String output=null, path=null, error=null, incs=null;
		f.setExterns(false);
		f.setGraphType(DibuixGraf.Tipus.arbre);
		f.setRootShow(false);
		
		OutputFormat of= OutputFormat.graphic;
		for(String s : args) {
			if("+system".equals(s))
				f.setExterns(true);
			else if("-system".equals(s))
				f.setExterns(false);
			else if("--help".equals(s)) {
				printHelp();
				System.exit(0);
			} else if("--output=".startsWith(s)) {
				output=s.split("=")[1];
				if(of.equals(OutputFormat.graphic))
					of=OutputFormat.png;
			} else if(s.startsWith("--incs=")) {
				incs = s.split("=")[1];
			} else if(s.startsWith("-T")) {
				if("--output=".equals(s))
					of=OutputFormat.png;
				else if("-Tjpg".equals(s))
					of=OutputFormat.png;
				else if("-Tdot".equals(s))
					of=OutputFormat.png;
				else 
					error="Unknown format: "+s;
					
			} else 				
				path=s;
			
			if(error!=null) {
				System.err.println(error);
				printHelp();
				System.exit(1);
			}
		}
		
		if(path==null) {
			System.err.println("You should specify a path to look at.");
			System.exit(1);
		} else {
			f.setPath(path, incs);
			if(of==OutputFormat.graphic)
				f.setVisible(true);
			else {
				f.export(output, of);
			}
			f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		}
	}
	private static void printHelp() {
		System.out.print(
				"This software will let you know which are the header dependencies of your C/C++ software.\n"+
				"Usage: headerDeps [OPTIONS] PROJECT_PATH\n"+
				"Options:\n"+
				"	--help			Display this information.\n"+
				"	[+|-]system		Enables/Disables system headers.\n"+
				"	-Tf				Displays the output information in 'f' format. Should specify an output.\n"+
				"	--output=path	Outputs information into a file.\n"+
				"	--incs=path		A file with the cpp parameters.\n"+
				"");
	}

}
